/// @cond EO_CXX_EO_IMPL

inline void elm::hoversel::hover_begin() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_begin());
}

inline void elm::hoversel::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_clear());
}

inline void elm::hoversel::hover_end() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_end());
}

inline ::elm::widget_item elm::hoversel::item_add(::efl::eina::optional< ::efl::eina::string_view > label_, ::efl::eina::optional< ::efl::eina::string_view > icon_file_, Elm_Icon_Type icon_type_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_item_add(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_file_), icon_type_, func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::hoversel::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::hoversel::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline ::evas::object elm::hoversel::hover_parent_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_hover_parent_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::hoversel::hover_parent_set(::evas::object parent_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_parent_set(::efl::eolian::to_c(parent_)));
}

inline bool elm::hoversel::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::hoversel::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool elm::hoversel::auto_update_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_auto_update_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::hoversel::auto_update_set(bool auto_update_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_auto_update_set(::efl::eolian::to_c(auto_update_)));
}

inline void eo_cxx::elm::hoversel::hover_begin() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_begin());
}

inline void eo_cxx::elm::hoversel::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_clear());
}

inline void eo_cxx::elm::hoversel::hover_end() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_end());
}

inline ::elm::widget_item eo_cxx::elm::hoversel::item_add(::efl::eina::optional< ::efl::eina::string_view > label_, ::efl::eina::optional< ::efl::eina::string_view > icon_file_, Elm_Icon_Type icon_type_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_item_add(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_file_), icon_type_, func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::hoversel::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::hoversel::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline ::evas::object eo_cxx::elm::hoversel::hover_parent_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_hover_parent_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::hoversel::hover_parent_set(::evas::object parent_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_hover_parent_set(::efl::eolian::to_c(parent_)));
}

inline bool eo_cxx::elm::hoversel::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::hoversel::items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool eo_cxx::elm::hoversel::auto_update_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_hoversel_auto_update_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::hoversel::auto_update_set(bool auto_update_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_hoversel_auto_update_set(::efl::eolian::to_c(auto_update_)));
}

inline ::eo_cxx::elm::hoversel::operator ::elm::hoversel() const
{
   return *static_cast<::elm::hoversel const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::hoversel::operator ::elm::hoversel&()
{
   return *static_cast<::elm::hoversel*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::hoversel::operator ::elm::hoversel const&() const
{
   return *static_cast<::elm::hoversel const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_hoversel_hover_begin_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->hover_begin();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_hoversel_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_hoversel_hover_end_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->hover_end();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_hoversel_item_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * label_, const char * icon_file_, Elm_Icon_Type icon_type_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_add(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(label_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(icon_file_, std::tuple<std::false_type>()), icon_type_, func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_hoversel_horizontal_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->horizontal_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_hoversel_horizontal_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   try
      {
         static_cast<T*>(self->this_)->horizontal_set(::efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::evas::object elm_hoversel_hover_parent_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->hover_parent_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_hoversel_hover_parent_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * parent_)
{
   try
      {
         static_cast<T*>(self->this_)->hover_parent_set(::efl::eolian::to_cxx<::evas::object>(parent_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_hoversel_expanded_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->expanded_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_hoversel_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
bool elm_hoversel_auto_update_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->auto_update_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_hoversel_auto_update_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool auto_update_)
{
   try
      {
         static_cast<T*>(self->this_)->auto_update_set(::efl::eolian::to_cxx<bool>(auto_update_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::hoversel >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::button >::template type<T>
         , virtual operations< ::evas::selectable_interface >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void hover_begin()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_hover_begin());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_clear());
      }

      virtual void hover_end()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_hover_end());
      }

      virtual ::elm::widget_item item_add(::efl::eina::optional< ::efl::eina::string_view > label_, ::efl::eina::optional< ::efl::eina::string_view > icon_file_, Elm_Icon_Type icon_type_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_item_add(::efl::eolian::to_c(label_), ::efl::eolian::to_c(icon_file_), icon_type_, func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_horizontal_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_horizontal_set(::efl::eolian::to_c(horizontal_)));
      }

      virtual ::evas::object hover_parent_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_hover_parent_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hover_parent_set(::evas::object parent_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_hover_parent_set(::efl::eolian::to_c(parent_)));
      }

      virtual bool expanded_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_expanded_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual bool auto_update_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_hoversel_auto_update_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void auto_update_set(bool auto_update_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_hoversel_auto_update_set(::efl::eolian::to_c(auto_update_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::hoversel >
{
   static constexpr int value = 
#if defined(HOVERSEL_PROTECTED) && defined(HOVERSEL_BETA)
      12
#elif defined(HOVERSEL_PROTECTED)
      12
#elif defined(HOVERSEL_BETA)
      12
#else
      12
#endif
      + operation_description_class_size<::elm::button >::value      + operation_description_class_size<::evas::selectable_interface >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::hoversel>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_hover_begin_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_hover_begin);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_hover_end_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_hover_end);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_item_add_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_item_add);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_horizontal_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_horizontal_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_horizontal_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_horizontal_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_hover_parent_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_hover_parent_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_hover_parent_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_hover_parent_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_expanded_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_expanded_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_auto_update_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_auto_update_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_hoversel_auto_update_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_hoversel_auto_update_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::button>(), &ops[operation_description_class_size< ::elm::hoversel >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::selectable_interface>(), &ops[operation_description_class_size< ::elm::hoversel >::value + operation_description_class_size<::elm::button>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::hoversel >::value + operation_description_class_size<::elm::button>::value + operation_description_class_size<::evas::selectable_interface>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::hoversel >::value + operation_description_class_size<::elm::button>::value + operation_description_class_size<::evas::selectable_interface>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::hoversel>)
{
   return (ELM_HOVERSEL_CLASS);
}

} } }

/// @endcond

